diff --git a/src/hyperv/hyperv_driver.c b/src/hyperv/hyperv_driver.c
index b539541..2f495d4 100644
--- a/src/hyperv/hyperv_driver.c
+++ b/src/hyperv/hyperv_driver.c
@@ -867,8 +867,8 @@ hypervDomainGetXMLDesc(virDomainPtr domain, unsigned int flags)
     if (VIR_STRDUP(def->name, computerSystem->data->ElementName) < 0)
         goto cleanup;
 
-    if (VIR_STRDUP(def->description, virtualSystemSettingData->data->Notes) < 0)
-        goto cleanup;
+    //if (VIR_STRDUP(def->description, virtualSystemSettingData->data->Notes) < 0)
+    //    goto cleanup;
 
     virDomainDefSetMemoryInitial(def, memorySettingData->data->Limit * 1024); /* megabyte to kilobyte */
     def->mem.cur_balloon = memorySettingData->data->VirtualQuantity * 1024; /* megabyte to kilobyte */
diff --git a/src/hyperv/hyperv_wmi.c b/src/hyperv/hyperv_wmi.c
index 13acd09..a66dc33 100644
--- a/src/hyperv/hyperv_wmi.c
+++ b/src/hyperv/hyperv_wmi.c
@@ -40,7 +40,7 @@
     "http://schemas.microsoft.com/wbem/wsman/1/wmi/root/cimv2/*"
 
 #define ROOT_VIRTUALIZATION \
-    "http://schemas.microsoft.com/wbem/wsman/1/wmi/root/virtualization/*"
+    "http://schemas.microsoft.com/wbem/wsman/1/wmi/root/virtualization/v2/*"
 
 #define VIR_FROM_THIS VIR_FROM_HYPERV
 
diff --git a/src/hyperv/hyperv_wmi_generator.input b/src/hyperv/hyperv_wmi_generator.input
index 97f9dff..4fb8a53 100644
--- a/src/hyperv/hyperv_wmi_generator.input
+++ b/src/hyperv/hyperv_wmi_generator.input
@@ -97,80 +97,90 @@ end
 
 
 class Msvm_MemorySettingData
-    string   Caption
-    string   Description
-    string   InstanceID
-    string   ElementName
-    uint16   ResourceType
-    string   OtherResourceType
-    string   ResourceSubType
-    string   PoolID
-    uint16   ConsumerVisibility
-    string   HostResource[]
-    string   AllocationUnits
-    uint64   VirtualQuantity
-    uint64   Reservation
-    uint64   Limit
-    uint32   Weight
-    boolean  AutomaticAllocation
-    boolean  AutomaticDeallocation
-    string   Parent
-    string   Connection[]
-    string   Address
-    uint16   MappingBehavior
-    boolean  IsVirtualized
-    string   DeviceID
-    string   DeviceIDFormat
-    boolean  DynamicMemoryEnabled
-#    uint32   TargetMemoryBuffer # Available only on Windows Server 2008 R2 SP1
+    string  InstanceID
+    string  Caption
+    string  Description
+    string  ElementName
+    uint16  ResourceType
+    string  OtherResourceType
+    string  ResourceSubType
+    string  PoolID
+    uint16  ConsumerVisibility
+    string  HostResource[]
+    string  AllocationUnits
+    uint64  VirtualQuantity
+    uint64  Reservation
+    uint64  Limit
+    uint32  Weight
+    boolean AutomaticAllocation
+    boolean AutomaticDeallocation
+    string  Parent
+    string  Connection[]
+    string  Address
+    uint16  MappingBehavior
+    string  AddressOnParent
+    string  VirtualQuantityUnits
+    boolean DynamicMemoryEnabled
+    uint32  TargetMemoryBuffer
+    boolean IsVirtualized
+    boolean SwapFilesInUse
+    uint64  MaxMemoryBlocksPerNumaNode
 end
 
 
 class Msvm_ProcessorSettingData
-    string   Caption
-    string   Description
-    string   InstanceID
-    string   ElementName
-    uint16   ResourceType
-    string   OtherResourceType
-    string   ResourceSubType
-    string   PoolID
-    uint16   ConsumerVisibility
-    string   HostResource[]
-    string   AllocationUnits
-    uint64   VirtualQuantity
-    uint64   Reservation
-    uint64   Limit
-    uint32   Weight
-    boolean  AutomaticAllocation
-    boolean  AutomaticDeallocation
-    string   Parent
-    string   Connection[]
-    string   Address
-    uint16   MappingBehavior
-    boolean  IsVirtualized
-    string   DeviceID
-    string   DeviceIDFormat
-    uint16   ProcessorsPerSocket
-    uint16   SocketCount
-    boolean  ThreadsEnabled
-    boolean  LimitCPUID
-    boolean  LimitProcessorFeatures
+    string  InstanceID
+    string  Caption
+    string  Description
+    string  ElementName
+    uint16  ResourceType
+    string  OtherResourceType
+    string  ResourceSubType
+    string  PoolID
+    uint16  ConsumerVisibility
+    string  HostResource[]
+    string  AllocationUnits
+    uint64  VirtualQuantity
+    uint64  Reservation
+    uint64  Limit
+    uint32  Weight
+    boolean AutomaticAllocation
+    boolean AutomaticDeallocation
+    string  Parent
+    string  Connection[]
+    string  Address
+    uint16  MappingBehavior
+    string  AddressOnParent
+    string  VirtualQuantityUnits
+    boolean LimitCPUID
+    boolean LimitProcessorFeatures
+    uint64  MaxProcessorsPerNumaNode
+    uint64  MaxNumaNodesPerSocket
 end
 
 
 class Msvm_VirtualSystemSettingData
+    string   InstanceID
     string   Caption
     string   Description
     string   ElementName
-    string   InstanceID
-    string   SystemName
-    uint16   SettingType
-    uint16   VirtualSystemType
-    string   OtherVirtualSystemType
-    boolean  AutoActivate
+    string   VirtualSystemIdentifier
+    string   VirtualSystemType
+    string   Notes[]
     datetime CreationTime
-    string   Notes
+    string   ConfigurationID
+    string   ConfigurationDataRoot
+    string   ConfigurationFile
+    string   SnapshotDataRoot
+    string   SuspendDataRoot
+    string   SwapFileDataRoot
+    string   LogDataRoot
+    uint16   AutomaticStartupAction
+    datetime AutomaticStartupActionDelay
+    uint16   AutomaticStartupActionSequenceNumber
+    uint16   AutomaticShutdownAction
+    uint16   AutomaticRecoveryAction
+    string   RecoveryFile
     string   BIOSGUID
     string   BIOSSerialNumber
     string   BaseBoardSerialNumber
@@ -179,8 +189,22 @@ class Msvm_VirtualSystemSettingData
     boolean  BIOSNumLock
     uint16   BootOrder[]
     string   Parent
-    uint16   NumaNodeList[]
-    boolean  NumaNodesAreRequired
+    boolean  IsSaved
+    string   AdditionalRecoveryInformation
+    boolean  AllowFullSCSICommandSet
+    uint32   DebugChannelId
+    uint16   DebugPortEnabled
+    uint32   DebugPort
+    string   Version
+    boolean  IncrementalBackupEnabled
+    boolean  VirtualNumaEnabled
+    boolean  AllowReducedFcRedundancy
+    string   VirtualSystemSubType
+    string   BootSourceOrder[]
+    boolean  PauseAfterBootFailure
+    uint16   NetworkBootPreferredProtocol
+    boolean  SecureBootEnabled
+    uint64   LowMmioGapSize
 end
 
 
diff --git a/src/hyperv/hyperv_wmi_generator.py b/src/hyperv/hyperv_wmi_generator.py
index f767d54..af3ce7e 100755
--- a/src/hyperv/hyperv_wmi_generator.py
+++ b/src/hyperv/hyperv_wmi_generator.py
@@ -71,7 +71,7 @@ class Class:
         if self.name.startswith("Win32_"):
             header += "    \"http://schemas.microsoft.com/wbem/wsman/1/wmi/root/cimv2/%s\"\n" % self.name
         else:
-            header += "    \"http://schemas.microsoft.com/wbem/wsman/1/wmi/root/virtualization/%s\"\n" % self.name
+            header += "    \"http://schemas.microsoft.com/wbem/wsman/1/wmi/root/virtualization/v2/%s\"\n" % self.name
 
         header += "\n"
         header += "#define %s_CLASSNAME \\\n" % name_upper
